﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Drawing;
using System.Diagnostics;

namespace WindowsFormsApplication17
{
    class DF : IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            CellUIElement cell = drawParams.Element as CellUIElement;

            if (cell != null && cell.Column.Group != null )
            {
                Pen pen = new Pen(Color.CornflowerBlue);
                pen.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
                pen.Width = 2;

                if (cell.Column.Group.Columns[0].Equals(cell.Column))
                {
                    drawParams.Graphics.DrawLine(pen, new Point(cell.Rect.Location.X, cell.Rect.Location.Y - 1), new Point(cell.Rect.Left, cell.Rect.Bottom + 1));
                    cell.Rect.Location.Offset(1, 0);
                }

                if (cell.Column.Group.Columns[cell.Column.Group.Columns.Count - 1].Equals(cell.Column))
                {
                    Point point = new Point(cell.Column.Header.GetUIElement().Rect.Right, cell.Rect.Location.Y - 1);

                    drawParams.Graphics.DrawLine(pen, new Point(cell.Column.Header.GetUIElement().Rect.Right, cell.Rect.Location.Y - 1), new Point(cell.Column.Header.GetUIElement().Rect.Right, cell.Rect.Bottom + 1));

                    cell.Rect = new Rectangle(cell.Rect.Location, new Size(cell.Column.Header.GetUIElement().Rect.Width - 1, cell.Rect.Height));
                }

                return true;
            }

            HeaderUIElement header = drawParams.Element as HeaderUIElement;

            if (header != null && header.Header.Column !=null && header.Header.Column.Group != null)
            {
                Pen pen = new Pen(Color.CornflowerBlue, 2);
                pen.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
                pen.Width = 2;

                if (header.Header.Column.Group.Columns[0].Equals(header.Header.Column))
                    drawParams.Graphics.DrawLine(pen, new Point(header.Rect.Location.X - 1, header.Rect.Location.Y - 1), new Point(header.Rect.Left - 1, header.Rect.Bottom + 1));

                if (header.Header.Column.Group.Columns[header.Header.Column.Group.Columns.Count - 1].Equals(header.Header.Column))
                    drawParams.Graphics.DrawLine(pen, new Point(header.Rect.Right, header.Rect.Location.Y - 1), new Point(header.Rect.Right, header.Rect.Bottom + 1));

                return true;
            }



            if (header != null)
            {

                if (header.Header.Caption == "Contact Info")
                {
                    Pen pen = new Pen(Color.CornflowerBlue);
                    pen.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
                    pen.Width = 2;

                    drawParams.Graphics.DrawLine(pen, new Point(header.Rect.Location.X - 1, header.Rect.Location.Y - 1), new Point(header.Rect.Left - 1, header.Rect.Bottom + 1));
                    drawParams.Graphics.DrawLine(pen, new Point(header.Rect.Location.X + header.Rect.Width, header.Rect.Location.Y), new Point(header.Rect.Right - 1, header.Rect.Bottom + 1));

                    return true;
                }

            }

            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is CellUIElement)
                return Infragistics.Win.DrawPhase.AfterDrawBorders;
            if (drawParams.Element is HeaderUIElement)
                return Infragistics.Win.DrawPhase.AfterDrawBorders;
            return DrawPhase.None;
        }
    }
}
